
#include "vms_db_module.h"


PyroSMSCDB :: PyroSMSCDB ( string user, string password, string database_name )
{
	db_name = database_name ;
	db_password = password ;
	db_user = user ;
	con = NULL;
//	env = NULL;
}
	
PyroSMSCDB::~PyroSMSCDB ()
{
	if ( IsConnected() )
		Disconnect ();	
}

int PyroSMSCDB ::ConnectToDB ()
{
	int Result = FALSE;

	try
	{
		if ( con == NULL )
		{
			if ( (db_user.size () == 0) && (db_password.size () == 0) && (db_name.size()  == 0) )
				Result = FALSE;
			else
			{
				env = Environment::createEnvironment (Environment::DEFAULT);
				con = env->createConnection (db_user, db_password, db_name);
				Result = TRUE;
			}
		}
		else
		{
			error = "Connection Already Created";
			Result = FALSE;
		}			
	}
	catch ( SQLException e )
	{
		error = e.what ();
		cout << error.c_str () << endl;
		Result = FALSE;
	}

	return Result;
}

int PyroSMSCDB::Disconnect ()
{
	int Result = FALSE;

	try
	{
		if ( con != NULL )
		{
			env->terminateConnection (con);
			con = NULL;
		}
		Result = TRUE;
	}
	catch ( SQLException e )
	{
		error = e.what ();
		Result = FALSE;
	}

	return Result;
}

bool PyroSMSCDB::IsConnected ()
{
	bool Result = FALSE;
	
	try
	{		
		if ( con != NULL )
		{
			Statement *st = con->createStatement ( "select SYSDATE from dual" );
			Result = TRUE;
			con->terminateStatement ( st );
		}
		else
		{
			error = "Connection dosen't exists";
			Result = FALSE;
		}
	}
	catch ( SQLException e )
	{
		error = e.what ();
		Result = FALSE;
	}

	return Result;
}

int PyroSMSCDB::MakeDelete ( string query )
{
	int Result = FALSE;
	Statement *st = NULL;
	
	effectedRows = 0;
	try
	{
		if ( con != NULL )
		{
			st = con->createStatement ( query );
			effectedRows = st->executeUpdate ();
			con->commit ();
			con->terminateStatement ( st );
			st = NULL;
			Result = TRUE;
		}
		else
		{
			error = "Connection dosen't exists";
			Result = FALSE;
		}
	}
	catch ( SQLException e )
	{
		error = e.what ();
		Result = FALSE;
		if ( st != NULL )
		{
			//con->commit ();
			con->terminateStatement ( st );
		}
	}

	return Result;
}

int PyroSMSCDB::MakeUpdate ( string query )
{
	int Result = FALSE;
	Statement *st = NULL;

	effectedRows = 0;
	try
	{
		if ( con != NULL )
		{
			st = con->createStatement ( query );
			effectedRows = st->executeUpdate ();
			con->commit();
			con->terminateStatement ( st );
			st = NULL;
			Result = TRUE;
		}
		else
		{
			error = "Connection dosen't exists";
			Result = FALSE;
		}
	}
	catch ( SQLException e )
	{
		error= e.what ();		
		Result = FALSE;
		if ( st != NULL )
		{
			//con->commit ();
			con->terminateStatement ( st );
		}
	}
	
	return Result;
}

int PyroSMSCDB::MakeUpdateWOCommit ( string query )
{
	int Result = FALSE;
	Statement *st = NULL;

	effectedRows = 0;
	try
	{
		if ( con != NULL )
		{
			st = con->createStatement ( query );
			effectedRows = st->executeUpdate ();
			con->terminateStatement ( st );
			st = NULL;
			Result = TRUE;
		}
		else
		{
			error = "Connection dosen't exists";
			Result = FALSE;
		}
	}
	catch ( SQLException e )
	{
		error= e.what ();		
		Result = FALSE;
		if ( st != NULL )
		{
			con->commit ();
			con->terminateStatement ( st );
		}
	}
	
	return Result;
}

int PyroSMSCDB::Commit ()
{
	int Result = FALSE;

	if ( con != NULL )
	{
		con->commit ();
		Result = TRUE;
	}
	else
	{
		error = "Connection doesn't exists";
		Result = FALSE;
	}

	return Result;
}

ResultSet* PyroSMSCDB::GetDataFromSelect ( string query )
{
	ResultSet *rs = NULL;
	Statement *st = NULL;
	
	try
	{
		if ( con != NULL )
		{
			st = con->createStatement( query );
			rs = st->executeQuery ();		
		}
		else
		{
			error = "Connection doesn't exists";
			rs = NULL;
		}
	}
	catch ( SQLException e )
	{
		error = e.what ();
		if ( rs != NULL )
		{
			st->closeResultSet (rs);
		}
		if ( st != NULL )
		{
			con->terminateStatement ( st );
		}		
	}
	catch ( exception e )
	{
		error = e.what ();
		if ( rs != NULL )
		{
			st->closeResultSet (rs);
		}
		if ( st != NULL )
		{
			con->terminateStatement ( st );
		}
		rs = NULL;
	}

	return rs;
}

int PyroSMSCDB::CloseResultSet ( ResultSet *rs )
{
	int Result = FALSE;
	Statement *st;
	Connection *con;

	try
	{
		if ( rs != NULL )
		{
			st = rs->getStatement ();
			con = st->getConnection ();
			st->closeResultSet ( rs );
			rs = NULL;
			con->terminateStatement ( st );
			st = NULL;
			Result = TRUE;			
		}
		else
		{
			error = "ResultSet doesn't exists";
			Result = FALSE;
		}
	}	
	catch ( SQLException e )
	{
		error = e.what ();
		Result = FALSE;
		if ( rs != NULL )
		{
			st->closeResultSet (rs);
		}
		if ( st != NULL )
		{
			con->terminateStatement ( st );
		}
	}

	return Result;
}

unsigned long PyroSMSCDB::Proc_Add_Mo( string query )
{
	unsigned long Result = FALSE;
	Statement *st = NULL;

	try
	{
		if ( con != NULL )
		{
			st = con->createStatement ( query );
			st->registerOutParam ( 1, OCCINUMBER);
			st->executeUpdate ();
			con->commit();
			Result = st->getNumber (1);
			con->terminateStatement ( st );
			st = NULL;
			//Result = TRUE;
		}
		else
		{
			error = "Connection doesn't exists";
			Result = FALSE;
		}
	}
	catch ( SQLException e )
	{
		error = e.what ();
		Result = FALSE;
		if ( st != NULL )
		{
			con->terminateStatement ( st );
		}
	}

	return Result;
}

