#ifndef _DB_MODULE_
#define _DB_MODULE_

#include <iostream>
#include <string>

#ifndef OCCI_ORACLE
# define OCCI_ORACLE
#endif

#ifndef OCCICOMMON_ORACLE
#include <occiCommon.h>
#endif

#ifndef OCCIDATA_ORACLE
#include <occiData.h>
#endif

#ifndef OCCICONTROL_ORACLE
#include <occiControl.h>
#endif

#ifndef OCCIOBJECTS_ORACLE
#include <occiObjects.h>
#endif

using namespace oracle::occi;
using namespace std;

class PyroSMSCDB
{

private:
	Environment *env;
	Connection *con;	// database Connection pointer
	string db_name;		// database name ( host string )
	string db_user;		// database user name
	string db_password;	// database password
	ResultSet *rs;		// contains resultset from a select query
public :

	long	effectedRows;	
	string error;		// will contain error string in the case of any error	
	PyroSMSCDB ( string db_user, string db_password, string db_name ) ;	
	~PyroSMSCDB () ;
	
	int ConnectToDB ();	// for making connection to the database
	int Disconnect ();	// disconnect fro the database 
	bool IsConnected ();	// check connection is there or not
	int MakeUpdate ( string query);	// for execute an update statement
	int MakeUpdateWOCommit( string query);
	int MakeDelete ( string query);	// for execute an delete statement
	int Commit ();	// for commit the transactions
	ResultSet* GetDataFromSelect ( string query);	// for getting the data as resultset
	int CloseResultSet ( ResultSet *rs);	// for closing the resultset
	unsigned long Proc_Add_Mo( string query );	// for executing the procedure (add_mo)

};// end of PyroSMSCDb class


#endif



